Global $g_appName		= StringTrimRight(@ScriptName, 4)
Global $g_iniFile		= @ScriptDir & "\" & "react.ini"
Global $g_mediaChangerExe	= "mediachanger.exe"

Global $g_eacTitle		= "Exact Audio Copy"
Global $g_eacText		= "CD Artist"
WinActivate($g_eacTitle, $g_eacText)
ControlSetText($g_eacTitle, $g_eacText, "myedit1", "Unknown Title-- Changer Slot ##")

Exit

fMain()

Func fMain()
	Local $currentDisk
	Local $ec
	$g_mediaChangerExe = IniRead($g_iniFile, "Settings", "MediaChanger", $g_mediaChangerExe)

	; See if we have a disk in the changer.  If so get it's source -- we'll start from that point.
	; Otherwise we mount disk 0 and start from there
	$currentDisk = fCurrentDisk()

	If $currentDisk < 0 Then
		; the drive is empty, mount disk 0
		fMountDisk(0)
	EndIf

	; check to make sure that we do have a disk now
	$currentDisk = RunWait($g_mediaChangerExe & " drivestatus", "", @SW_HIDE);
	If $currentDisk < 0 Then
		fErrorOut("The drive should not be empty")
		Exit
	EndIf

	; Now we have a disk mounted, we'll start ripping from there
	Local $ec
	Do
		; do something with the current one
		$currentDisk = RunWait($g_mediaChangerExe & " drivestatus", "", @SW_HIDE);
		MsgBox(0, "current disk", $currentDisk);

		; mount the next one
		$ec = fMountNextDisk()
	Until $ec == 0
EndFunc

; Mount the disk in $slot.  The drive must be empty to do this without error
Func fMountDisk($slot)
	Local $ec

	$ec = RunWait($g_mediaChangerExe & " mount " & $slot, "", @SW_HIDE)
	If $ec == -1 Then
		fErrorOut("Mounting disk in slot " & $slot & " failed")
	EndIf
EndFunc

; Mount the next disk.  Returns 0 when there are no more disks
Func fMountNextDisk()
	Local $ec

	$ec = RunWait($g_mediaChangerExe & " next", "", @SW_HIDE)
	If $ec == -1 Then
		fErrorOut("Mounting the next disk failed")
	EndIf

	return $ec
EndFunc

; Which disk is currently mounted?  A negative number means the drive is empty
Func fCurrentDisk()
	$currentDisk = RunWait($g_mediaChangerExe & " drivestatus", "", @SW_HIDE)
	If $currentDisk == -1 Then
		fErrorOut("MediaChanger drivestatus command failed")
	EndIf
	return $currentDisk
EndFunc

Func fErrorOut($message)
	MsgBox(0, "REACT -- MediaChanger", $message)
	Exit
EndFunc
